diff --git a/arch/arm/mach-s3c2410/mach-gta01.c b/arch/arm/mach-s3c2410/mach-gta01.c
index 0cef057..9af5198 100644
--- a/arch/arm/mach-s3c2410/mach-gta01.c
+++ b/arch/arm/mach-s3c2410/mach-gta01.c
@@ -460,6 +462,9 @@ static struct vbus_draw gta01_udc_vbus_drawer;
 
 static void __gta01_udc_vbus_draw(struct work_struct *work)
 {
+	if (!pcf50606_global)
+		return;
+
 	if (gta01_udc_vbus_drawer.ma >= 500) {
 		/* enable fast charge */
 		printk(KERN_DEBUG "udc: enabling fast charge\n");
diff --git a/drivers/i2c/chips/pcf50606.c b/drivers/i2c/chips/pcf50606.c
index 78ca662..86e35a4 100644
--- a/drivers/i2c/chips/pcf50606.c
+++ b/drivers/i2c/chips/pcf50606.c
@@ -1601,8 +1601,6 @@ static int pcf50606_detect(struct i2c_adapter *adapter, int address, int kind)
 		goto exit_free;
 	}
 
-	pcf50606_global = data;
-
 	populate_sysfs_group(data);
 
 	err = sysfs_create_group(&new_client->dev.kobj, &pcf_attr_group);
@@ -1649,6 +1647,8 @@ static int pcf50606_detect(struct i2c_adapter *adapter, int address, int kind)
 		dev_err(&new_client->dev, "IRQ %u cannot be enabled as wake-up"
 		        "source in this hardware revision!", irq);
 
+	pcf50606_global = data;
+
 	if (data->pdata->used_features & PCF50606_FEAT_RTC) {
 		data->rtc = rtc_device_register("pcf50606", &new_client->dev,
 						&pcf50606_rtc_ops, THIS_MODULE);
@@ -1725,16 +1725,16 @@ exit_rtc:
 		rtc_device_unregister(pcf50606_global->rtc);
 exit_irq:
 	free_irq(pcf50606_global->irq, pcf50606_global);
+	pcf50606_global = NULL;
 exit_input:
 	pm_power_off = NULL;
-	input_unregister_device(pcf50606_global->input_dev);
+	input_unregister_device(data->input_dev);
 exit_sysfs:
 	sysfs_remove_group(&new_client->dev.kobj, &pcf_attr_group);
 exit_detach:
 	i2c_detach_client(new_client);
 exit_free:
 	kfree(data);
-	pcf50606_global = NULL;
 	return err;
 }
 